#ifndef M68KIntrfH
#define M68KIntrfH
#endif

/* defined in m68k_cmn_intrf.cpp */
extern int uae4all_go_interrupt;
extern unsigned mispcflags;

void init_memmaps(addrbank* banco);
void map_zone(unsigned addr, addrbank* banco, unsigned realstart);
void m68k_go(int may_quit);
void init_m68k(void);

#define _68k_spcflags mispcflags
#define fill_prefetch_0()
#define dump_counts()
#define flush_icache(X)

#define M68KCONTEXT m68kcontext
#define IO_CYCLE io_cycle_counter
extern int IO_CYCLE;
#define m68k_irq_update(end_timeslice) \
	if ((end_timeslice) && IO_CYCLE > 0) { \
		M68KCONTEXT.cycles_counter += 24 - IO_CYCLE; \
		IO_CYCLE = 24; \
	}

#include "m68k/fame/fame.h"
#include "memory.h"

extern struct M68K_CONTEXT M68KCONTEXT;

#define _68k_dreg(num) (M68KCONTEXT.dreg[(num)])
#define _68k_areg(num) (M68KCONTEXT.areg[(num)])
#define _68k_sreg 	M68KCONTEXT.sr
#define _68k_ispreg 	M68KCONTEXT.isp
#define _68k_mspreg 	M68KCONTEXT.msp
#define _68k_uspreg 	M68KCONTEXT.usp
#define _68k_intmask   ((M68KCONTEXT.sr >> 8) & 7)
#define _68k_incpc(o)  (M68KCONTEXT.pc += (o))

static __inline__ unsigned _68k_getpc(void)
{
//	return M68KCONTEXT.pc;
	return m68k_get_pc();
}
static __inline__ void _68k_setpc(unsigned mipc)
{
	M68KCONTEXT.pc=mipc;
	m68k_set_register(M68K_REG_PC, mipc);
}

static __inline__ void set_special (unsigned x)
{
    _68k_spcflags |= x;
}

static __inline__ void unset_special (uae_u32 x)
{
    _68k_spcflags &= ~x;
}

/* PocketUAE */
	/* UAE redefine */
	#define m68k_dreg(r,num) (m68kcontext.dreg[num])
	#define m68k_areg(r,num) (m68kcontext.areg[num])
	
	typedef char flagtype;
	
	/* You can set this to long double to be more accurate. However, the
	   resulting alignment issues will cost a lot of performance in some
	   apps */
	#define USE_LONG_DOUBLE 0
	
	#if USE_LONG_DOUBLE
	typedef long double fptype;
	#else
	typedef double fptype;
	#endif
	
	extern struct regstruct
	{
		uae_u32 regs[16];
		uaecptr  usp,isp,msp;
		uae_u16 sr;
		flagtype t1;
		flagtype t0;
		flagtype s;
		flagtype m;
		flagtype x;
		flagtype stopped;
		int intmask;
	
		uae_u32 pc;
		uae_u8 *pc_p;
		uae_u8 *pc_oldp;
	
		uae_u32 vbr,sfc,dfc;
	
		fptype fp[8];
		fptype fp_result;
	
		uae_u32 fpcr,fpsr,fpiar;
		uae_u32 fpsr_highbyte;
	
		uae_u32 spcflags;
		uae_u32 kick_mask;
	
		uae_u32 prefetch_pc;
		uae_u32 prefetch;
	} regs, lastint_regs;
/***************/
